guiKeyMouseEvents = {};

function guiKeyMouseEvents:setKeyMouse(self, unicode, sym, modifier, isDownKey, posX, posY, isDown, isUp, button)
	if unicode ~= nil then		
		if g_currentMission.guiMenue.on and not g_currentMission.guiMenue.dragDrop.on then 
			guiKeyMouseEvents:setKey(self, unicode, sym, modifier, isDownKey);
		elseif not g_currentMission.guiMenue.on and not g_currentMission.guiMenue.dragDrop.on then
			guiKeyMouseEvents:setKey(self, unicode, sym, modifier, isDownKey, true)
		end;
	else		
		if g_currentMission.guiMenue.on and not g_currentMission.guiMenue.dragDrop.on then 
			guiKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button);		
		elseif g_currentMission.guiMenue.on and g_currentMission.guiMenue.dragDrop.on then
			guiKeyMouseEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button);
		end;
	end;
end;

function guiKeyMouseEvents:setKey(self, unicode, sym, modifier, isDown, onlyMouse)
	--if onlyMouse and Input.isKeyPressed(Input.KEY_f12) then
	--	g_currentMission.guiMenue.on = true;
	--	g_currentMission.guiMenue.mod = 1;
	--	g_currentMission.isMouse = true;
	--	InputBinding.setShowMouseCursor(true);
	--end;
end;

function guiKeyMouseEvents:setDragDropMouse(self, posX, posY, isDown, isUp, button)	
	--g_currentMission.guiMenue.default.posX = g_currentMission.guiMenue.mouseCursor.posX;
	--g_currentMission.guiMenue.default.posY = g_currentMission.guiMenue.mouseCursor.posY-g_currentMission.guiMenue.default.height;
	if button == Input.MOUSE_BUTTON_LEFT and isDown then
		if g_currentMission.guiMenue.dragDrop.on then
			if g_currentMission.guiMenue.dragDrop.errorPos then
				g_currentMission.guiMenue.default.posX = g_currentMission.guiMenue.dragDrop.lastPosX;
				g_currentMission.guiMenue.default.posY = g_currentMission.guiMenue.dragDrop.lastPosY;
			end;
			guiMenue:stopDragDrop(self);			
			return;						
		end;
	end;
end;

function guiKeyMouseEvents:setMouse(self, posX, posY, isDown, isUp, button)	
	local infoTxt = false;
	local helpTxt = false;
	local pullDownLine = false;
	local markerColorButton = false;			
	if g_currentMission.guiMenue.clickAreas ~= nil and #g_currentMission.guiMenue.clickAreas > 0 then
		for a=1, #g_currentMission.guiMenue.clickAreas do
			if g_currentMission.guiMenue.clickAreas[a] ~= nil then				
				if guiMenue:mouseIsInArea(posX, posY, unpack(g_currentMission.guiMenue.clickAreas[a])) then						
					if g_currentMission.guiMenue.clickAreas[a].whereClick == "guiMasterMenue" then						
						guiMenue:stopHelpText(self);
						guiMenue:stopInfoText(self);
						--if g_currentMission.guiMenue.pullDown.open and (g_currentMission.guiMenue.pullDown.buttonType == "pullDownLineButton" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownOpenLineButtonModPage") then guiMenue:stopPullDown(self, "GuiMenue Master Page, close Slave Page");end;
						if button == Input.MOUSE_BUTTON_LEFT and isDown then							
							if g_currentMission.guiMenue.viewPage == 1 then g_currentMission.guiMenue.viewPage = 2;end;
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "dragDrop" then
								if not g_currentMission.guiMenue.dragDrop.on and isDown then									
									guiMenue:stopPullDown(self);									
									g_currentMission.guiMenue.dragDrop.lastPosX = g_currentMission.guiMenue.default.posX;
									g_currentMission.guiMenue.dragDrop.lastPosY = g_currentMission.guiMenue.default.posY;
									g_currentMission.guiMenue.dragDrop.on = true;
									g_currentMission.guiMenue.dragDrop.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whereClick);									
									g_currentMission.guiMenue.lastViewPage = g_currentMission.guiMenue.viewPage;
									g_currentMission.guiMenue.viewPage = 2;
								elseif g_currentMission.guiMenue.dragDrop.on and not isDown then
									if g_currentMission.guiMenue.dragDrop.errorPos then
										g_currentMission.guiMenue.default.posX = g_currentMission.guiMenue.dragDrop.lastPosX;
										g_currentMission.guiMenue.default.posY = g_currentMission.guiMenue.dragDrop.lastPosY;
									end;			
									guiMenue:stopDragDrop(self);									
								end;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "smallView" then
								if g_currentMission.guiMenue.viewPage == 0 then g_currentMission.guiMenue.viewPage=2;else g_currentMission.guiMenue.viewPage=0;end;
								g_currentMission.guiMenue.lastViewPage = g_currentMission.guiMenue.viewPage;
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "zoomIn" then
								if g_currentMission.guiMenue.default.zoomOutInTemp > g_currentMission.guiMenue.default.minZoomOutInTemp then
									g_currentMission.guiMenue.default.zoomOutInTemp = g_currentMission.guiMenue.default.zoomOutInTemp-g_currentMission.guiMenue.default.zoomOutInLevel;
									g_currentMission.guiMenue.guiSetGet:reloadMenueImages(self, true);
									g_currentMission.guiMenue.guiSetGetMenue:setMaxViewLineAtPage(true);
								end;
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "zoomOut" then
								if g_currentMission.guiMenue.default.zoomOutInTemp < g_currentMission.guiMenue.default.maxZoomOutInTemp then
									g_currentMission.guiMenue.default.zoomOutInTemp = g_currentMission.guiMenue.default.zoomOutInTemp+g_currentMission.guiMenue.default.zoomOutInLevel;
									g_currentMission.guiMenue.guiSetGet:reloadMenueImages(self, true);
									g_currentMission.guiMenue.guiSetGetMenue:setMaxViewLineAtPage(true);
								end;
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "save" and g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].tempSave then
								g_currentMission.guiMenue.pullDown.whatClick = "saveGuiMenue_"; ---for select and click (for a Mod) optional over onSaveCallback (for a Mod)
								guiMenue:stopPullDown(self);
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].save = true;
								g_currentMission.guiMenue.master:modOnSaveCallback(g_currentMission.guiMenue.mod); --onSaveCallback for Mods
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "close" then
								g_currentMission.guiMenue.pullDown.whatClick = "closeGuiMenue_"; ---for select and closeGuiMenue (for a Mod) optional over onCloseCallback (for a Mod)								
								guiMenue:stopPullDown(self);
								g_currentMission.guiMenue.on = false;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage= {masterPage=1, slavePage=1, pageSide=1};
								g_currentMission.guiMenue.master:modOnCloseCallback(g_currentMission.guiMenue.mod); --onCloseCallback(Master Mod Menue) for Mods
								g_currentMission.guiMenue.mod = 1;								
								return;	
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownModSlavePage" then
								if g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" then 
									guiMenue:stopPullDown(self, "pullDownModSlavePage return");									
									return;
								elseif g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType ~= "pullDownModSlavePage" then
									guiMenue:stopPullDown(self, "pullDownModSlavePage");
									g_currentMission.guiMenue.pullDown.line = 0;
									g_currentMission.guiMenue.pullDown.buttonType = "pullDownModSlavePage";										
								end;
								g_currentMission.guiMenue.pullDown.buttonType = "pullDownModSlavePage";
								g_currentMission.guiMenue.pullDown.clickArea = g_currentMission.guiMenue.clickAreas[a];
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whereClick);
								g_currentMission.guiMenue.pullDown.open = true;								
								return;							
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownModMasterPage" then								
								if g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownModMasterPage" then 
									guiMenue:stopPullDown(self, "pullDownModMasterPage return");									
									return;
								elseif g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType ~= "pullDownModMasterPage" then
									guiMenue:stopPullDown(self, "pullDownModMasterPage");
									g_currentMission.guiMenue.pullDown.line = 0;
									g_currentMission.guiMenue.pullDown.buttonType = "pullDownModMasterPage";										
								end;
								g_currentMission.guiMenue.pullDown.buttonType = "pullDownModMasterPage";
								g_currentMission.guiMenue.pullDown.clickArea = g_currentMission.guiMenue.clickAreas[a];
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whereClick);
								g_currentMission.guiMenue.pullDown.open = true;								
								return;								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownMods" then
								if g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods" then 
									guiMenue:stopPullDown(self, "pullDownMods return");
									return;
								elseif g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType ~= "pullDownMods" then
									guiMenue:stopPullDown(self, "pullDownMods");
									g_currentMission.guiMenue.pullDown.line = 0;
									g_currentMission.guiMenue.pullDown.buttonType = "pullDownMods";									
								end;
								g_currentMission.guiMenue.pullDown.buttonType = "pullDownMods";
								g_currentMission.guiMenue.pullDown.clickArea = g_currentMission.guiMenue.clickAreas[a];
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whereClick);
								g_currentMission.guiMenue.pullDown.open = true;
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenMods" then
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = "openMod_"; ---for select and openMod(close Pulldown) optional over onOpenCallback (for a Mod)
								g_currentMission.guiMenue.mod = g_currentMission.guiMenue.clickAreas[a].line;							
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage= {masterPage=1, slavePage=1, pageSide=1};
								guiMenue:stopPullDown(self, "pullDownOpenMods");
								g_currentMission.guiMenue.master:modOnOpenCallback(g_currentMission.guiMenue.mod); --onOpenCallback for Mods
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenModMasterPage" then
								---onClose/OpenCallback
								g_currentMission.guiMenue.master:modOnOpenCloseCallbackMasterPage(g_currentMission.guiMenue.mod, g_currentMission.guiMenue.clickAreas[a].line, "modMasterPageSide"); --callback
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = "openModMasterPage_"; ---for select and openModMasterPage...(close Pulldown) optional over onOpen/Close Callback (for a Mod)
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;														
								if g_currentMission.guiMenue.clickAreas[a].line ~= g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.masterPage then
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.masterPage = g_currentMission.guiMenue.clickAreas[a].line;
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.slavePage = 1;																	
								else --reset side 	for safety							
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
								end;								
								---onClose/OpenCallback								
								guiMenue:stopPullDown(self, "pullDownOpenModMasterPage");
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenModSlavePage" then															
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = "openModSlavePage_"; ---for select and openModSlavePage...(close Pulldown) optional over onOpen/Close Callback Side (for a Mod)
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;
								if g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.slavePage ~= g_currentMission.guiMenue.clickAreas[a].line then																
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.slavePage = g_currentMission.guiMenue.clickAreas[a].line;																	
								else --reset side for safety									
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
								end;														
								guiMenue:stopPullDown(self, "pullDownOpenModSlavePage");
								return;	
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideUpModMasterPage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideUpModSlavePage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideUpMods" then
								if g_currentMission.guiMenue.pullDown.bounds[1] > 1 then setPullDownBounds(true);end;
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
								return;
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownModMasterPage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownModSlavePage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownMods" then								
								if (g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownModMasterPage" and g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page)
								or (g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownModSlavePage" and g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].page)
								or (g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownMods" and g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable) then setPullDownBounds(false);end;								
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
								return;							
							end;						
						elseif button == Input.MOUSE_BUTTON_WHEEL_UP and isDown then							
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownMods" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownModMasterPage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownModSlavePage" then
								if g_currentMission.guiMenue.pullDown.bounds[1] > 1 then setPullDownBounds(true);end;								
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							end;
							return;
						elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN and isDown then
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownMods" then
								if g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable then setPullDownBounds(false);end;								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownModMasterPage" then 
								if g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page then setPullDownBounds(false);end;								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownModSlavePage" then 
								if g_currentMission.guiMenue.pullDown.bounds[2] < #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].page then setPullDownBounds(false);end;
							end;
							g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							return;
						else							
							guiMenue:resetReturnClickAll(self);
							if g_currentMission.guiMenue.clickAreas[a].buttonType ~= "pullDownOpenModMasterPage" and g_currentMission.guiMenue.clickAreas[a].buttonType ~= "pullDownOpenModSlavePage" and g_currentMission.guiMenue.clickAreas[a].buttonType ~= "pullDownOpenMods" and string.len(g_currentMission.guiMenue.clickAreas[a].infoTxt) > 0 then	
								g_currentMission.guiMenue.infoText.txt = g_currentMission.guiMenue.clickAreas[a].infoTxt;
								infoTxt = true;
							end;
							--for select ModPage Line and Pulldown isOpen
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenModMasterPage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenModSlavePage" or g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenMods" then
								g_currentMission.guiMenue.pullDown.line = g_currentMission.guiMenue.clickAreas[a].line;								
								pullDownLine = true;							
							end;
							--for select ModPage Line and Pulldown isOpen
							return;
						end;
					elseif 	g_currentMission.guiMenue.clickAreas[a].whereClick == "guiModPageMenue" then
						guiMenue:stopHelpText(self);
						guiMenue:stopInfoText(self);						
						if button == Input.MOUSE_BUTTON_LEFT and isDown then --close pulldown Gui Menue Master Page is click Gui Menue Slave Page
							if g_currentMission.guiMenue.pullDown.open and (g_currentMission.guiMenue.pullDown.buttonType == "pullDownModMasterPage" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownModSlavePage" or g_currentMission.guiMenue.pullDown.buttonType == "pullDownMods") then guiMenue:stopPullDown(self, "is pullDownMods or master or slave");end;
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "pageSideRight" then								
								if g_currentMission.guiMenue.clickAreas[a].pageType == "modMasterPageSide" then
									if g_currentMission.guiMenue.clickAreas[a].pageSide+1 > #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].side then 
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
									else
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = g_currentMission.guiMenue.clickAreas[a].pageSide+1;
									end;
								else
									if g_currentMission.guiMenue.clickAreas[a].pageSide+1 > #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].page[g_currentMission.guiMenue.clickAreas[a].slavePage].side then 
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = 1;
									else
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = g_currentMission.guiMenue.clickAreas[a].pageSide+1;
									end;
								end;
								guiMenue:modOnOpenCloseCallbackPageSide(g_currentMission.guiMenue.mod, g_currentMission.guiMenue.clickAreas[a].pageSide, g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide, g_currentMission.guiMenue.clickAreas[a].pageType);
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = "pageSideRight"								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pageSideLeft" then
								if g_currentMission.guiMenue.clickAreas[a].pageType == "modMasterPageSide" then
									if g_currentMission.guiMenue.clickAreas[a].pageSide-1 < 1 then 
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].side;
									else
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = g_currentMission.guiMenue.clickAreas[a].pageSide-1;
									end;
								else
									if g_currentMission.guiMenue.clickAreas[a].pageSide-1 < 1 then 
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = #g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.clickAreas[a].masterPage].page[g_currentMission.guiMenue.clickAreas[a].slavePage].side;
									else
										g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide = g_currentMission.guiMenue.clickAreas[a].pageSide-1;
									end;
								end;
								guiMenue:modOnOpenCloseCallbackPageSide(g_currentMission.guiMenue.mod, g_currentMission.guiMenue.clickAreas[a].pageSide, g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide, g_currentMission.guiMenue.clickAreas[a].pageType);
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = "pageSideLeft"
							end;							
						end;
						local modPageTable = getPageTable(g_currentMission.guiMenue.pullDown.buttonType, g_currentMission.guiMenue.clickAreas[a].pageType, g_currentMission.guiMenue.clickAreas[a].masterPage, g_currentMission.guiMenue.clickAreas[a].slavePage, g_currentMission.guiMenue.clickAreas[a].pageSide);
						if modPageTable ~= nil then
							if button == Input.MOUSE_BUTTON_WHEEL_UP and isDown and not g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.clickAreas[a].buttonType == "pageLineSlideUpDown" then							
								if modPageTable.viewLines.bounds[1] > 1 then setPageLinesBounds(true, modPageTable);end;
								return;
							elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN and isDown and not g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.clickAreas[a].buttonType == "pageLineSlideUpDown" then
								if modPageTable.viewLines.bounds[2] < #modPageTable.line then setPageLinesBounds(false, modPageTable);end;
								return;
							elseif button == Input.MOUSE_BUTTON_LEFT and isDown then
								if g_currentMission.guiMenue.clickAreas[a].buttonType == "pageLineUp" then								
									if modPageTable.viewLines.bounds[1] > 1 then guiMenue:stopPullDown(self, "pageLineUp");setPageLinesBounds(true, modPageTable);end;
								elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pageLineDown" then								
									if modPageTable.viewLines.bounds[2] < #modPageTable.line then guiMenue:stopPullDown(self, "pageLineDown");setPageLinesBounds(false, modPageTable);end;
								end;							
								return;
							else									
								guiMenue:resetReturnClickAll(self);
								if string.len(g_currentMission.guiMenue.clickAreas[a].infoTxt) > 0 then	
									g_currentMission.guiMenue.infoText.txt = g_currentMission.guiMenue.clickAreas[a].infoTxt;
									infoTxt = true;
								end;
								return;
							end;
						end;
					elseif 	g_currentMission.guiMenue.clickAreas[a].whereClick == "guiModPageLineMenue" then						
						--if g_currentMission.guiMenue.pullDown.open and string.find(g_currentMission.guiMenue.pullDown.buttonType, "pullDownPageLine") then guiMenue:stopPullDown(self);end;
						--{"slideUpLineButton", "slideDownLineButton", "slideUpDownLineButton"};
						if g_currentMission.guiMenue.clickAreas[a].buttonType ~= "clickHelpIcon" then guiMenue:stopHelpText(self);helpTxt = false;end;
						g_currentMission.guiMenue.pullDown.clickPullDownLine = false;
						if button == Input.MOUSE_BUTTON_LEFT and isDown then							
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "clickLineButton" or g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenLineButtonModPage" then														
								local closePullDown = false;
								if g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenLineButtonModPage" then									
									g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);									
									closePulldown = setPullDownMenueModPageLineNew(g_currentMission.guiMenue.clickAreas[a].line, g_currentMission.guiMenue.clickAreas[a].button, g_currentMission.guiMenue.clickAreas[a].pullDownLine);
									g_currentMission.guiMenue.pullDown.pullDownLine = g_currentMission.guiMenue.clickAreas[a].pullDownLine;
									pullDownLine = true;
									g_currentMission.guiMenue.pullDown.clickPullDownLine = true;									
									if closePulldown then 
										guiMenue:stopPullDown(self, "pullDownOpenLineButtonModPage closePullDown");									
									end;
								else
									g_currentMission.guiMenue.pullDown.clickPullDownLine = false;
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].tempSave=true;									
									guiMenue:stopPullDown(self, "pullDownOpenLineButtonModPage");
								end;							
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = g_currentMission.guiMenue.clickAreas[a].whatClick;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;
								return;								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "clickHelpIcon" then
								if string.len(g_currentMission.guiMenue.helpText.txt) > 0 then guiMenue:stopHelpText(self);return;end;
								g_currentMission.guiMenue.helpText.posX = g_currentMission.guiMenue.mouseCursor.posX;
								g_currentMission.guiMenue.helpText.posY = g_currentMission.guiMenue.mouseCursor.posY;
								g_currentMission.guiMenue.helpText.txt = g_currentMission.guiMenue.clickAreas[a].helpTxt;
								helpTxt = true;
								return;								
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideUpLineButton" then
								if g_currentMission.guiMenue.pullDown.bounds[1] > 1 then setPullDownBounds(true);end;								
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "slideDownLineButton" then
								local pullDownMaxLine = g_currentMission.guiMenue.clickAreas[a].pullDownMaxLine;
								if pullDownMaxLine ~= nil then
									if g_currentMission.guiMenue.pullDown.bounds[2] < tonumber(pullDownMaxLine) then
										setPullDownBounds(false)
									end;
								end;
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							elseif g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownLineButton" then								
								if g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType == "pullDownLineButton" then 
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = g_currentMission.guiMenue.clickAreas[a].whatClick; --for Mod Info openPullDown
									g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;
									guiMenue:stopPullDown(self, "pullDownLineButton return");									
									return;
								elseif g_currentMission.guiMenue.pullDown.open and g_currentMission.guiMenue.pullDown.buttonType ~= "pullDownLineButton" then
									guiMenue:stopPullDown(self, "pullDownLineButton");
									g_currentMission.guiMenue.pullDown.line = 0;
									g_currentMission.guiMenue.pullDown.buttonType = "pullDownLineButton";									
								end;
								g_currentMission.guiMenue.pullDown.buttonType = "pullDownLineButton";
								g_currentMission.guiMenue.pullDown.clickArea = g_currentMission.guiMenue.clickAreas[a];
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
								g_currentMission.guiMenue.pullDown.open = true;								
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = g_currentMission.guiMenue.clickAreas[a].whatClick; --for Mod Info openPullDown
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;
								return;							
							end;
						elseif button == Input.MOUSE_BUTTON_WHEEL_UP and isDown then							
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownLineButton" then
								if g_currentMission.guiMenue.pullDown.bounds[1] > 1 then setPullDownBounds(true);end;								
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							end;
						elseif button == Input.MOUSE_BUTTON_WHEEL_DOWN and isDown then							
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "slideLineUpDownLineButton" then
								local pullDownMaxLine = g_currentMission.guiMenue.clickAreas[a].pullDownMaxLine;
								if pullDownMaxLine ~= nil then
									if g_currentMission.guiMenue.pullDown.bounds[2] < tonumber(pullDownMaxLine) then
										setPullDownBounds(false)
									end;
								end;
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
							end;
						else
							guiMenue:resetReturnClickAll(self);							
							if g_currentMission.guiMenue.clickAreas[a].buttonType ~= "clickHelpIcon" then guiMenue:stopHelpText(self);helpTxt = false;end;
							if g_currentMission.guiMenue.clickAreas[a].buttonType == "pullDownOpenLineButtonModPage" then
								g_currentMission.guiMenue.pullDown.line = g_currentMission.guiMenue.clickAreas[a].pullDownLine;								
								g_currentMission.guiMenue.pullDown.whatClick = tostring(g_currentMission.guiMenue.clickAreas[a].whatClick);
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.pullDownLine = g_currentMission.guiMenue.clickAreas[a].pullDownLine; --> for check a mod, is new pulldownline select or for multiple select
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.name = g_currentMission.guiMenue.clickAreas[a].whatClick;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.line = g_currentMission.guiMenue.clickAreas[a].line;
								g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].returnClick.button = g_currentMission.guiMenue.clickAreas[a].button;
								pullDownLine = true;							
							end;							
							if string.len(g_currentMission.guiMenue.clickAreas[a].infoTxt) > 0 then	
								g_currentMission.guiMenue.infoText.txt = g_currentMission.guiMenue.clickAreas[a].infoTxt;
								infoTxt = true;
							end;
							return;
						end;
					end;
				end;
			end;
		end;
	end;	
	if not markerColorButton then
		--g_currentMission.guiMenue.markerColorButton = {posX=0;posY=0;width=0,height=0,colorName="",overlayName=""};
	end;
	if not pullDownLine then
		g_currentMission.guiMenue.pullDown.line = 0;
		g_currentMission.guiMenue.pullDown.pullDownLine = 0;
	end;
	if not infoTxt then		
		guiMenue:stopInfoText(self);		
	end;
	if not helpTxt then		
		guiMenue:stopHelpText(self);
	end;
end;

function getPageTable(pullDownName, pageType, masterPage, slavePage, pageSide)
	if pageType == nil then return;end;
	if pageType == "modSlavePageSide" then return g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[masterPage].page[slavePage].side[pageSide];end;	
	return g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[masterPage].side[pageSide];
end;

function setPullDownMenueModPageLineNew(line, button, pullDownLine)	
	if line == nil or line == 0 or button == nil or button == 0 or pullDownLine == nil or pullDownLine == 0 then return true;end;
	local closePullDownMenue = false;
	local modPageTable = Utils.getNoNil(g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.masterPage].side[g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide], nil);
	local pageType = guiSetGetMenue:getPageType(g_currentMission.guiMenue.mod)	
	if pageType == nil then return false;end;
	if pageType == "modSlavePageSide" then modPageTable = Utils.getNoNil(g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].page[g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.masterPage].page[g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.slavePage].side[g_currentMission.guiMenue.modTable[g_currentMission.guiMenue.mod].lastOpenPage.pageSide], nil);end;
	local buttonTable = Utils.getNoNil(modPageTable.line[line].button[button], nil);
	if buttonTable ~= nil then		
		local maxSelect = buttonTable.maxSelect or 1;
		local isSelect = 0;
		local foundSelect = 0;			
		if buttonTable.cmdTable[pullDownLine].isSelect and maxSelect <=1 then return true;end;		
		if buttonTable.changeAlone ~= nil and buttonTable.changeAlone then 
			if maxSelect > 1 then 
				return false;
			else
				return true;
			end;
		end;
		for a=1, #buttonTable.cmdTable do			
			if buttonTable.cmdTable[a].isSelect then				
				if a ~= pullDownLine and maxSelect <= 1 then
					buttonTable.cmdTable[a].isSelect = false;
					buttonTable.cmdTable[pullDownLine].isSelect = true;
					return true;
				end;
				foundSelect = foundSelect+1;
			end;			
		end;
		if foundSelect >= maxSelect and maxSelect > 1 then
			buttonTable.cmdTable[pullDownLine].isSelect = false;
		end;
		if foundSelect < maxSelect and maxSelect > 1 then 
			if buttonTable.cmdTable[pullDownLine].isSelect then 
				buttonTable.cmdTable[pullDownLine].isSelect = false;
			else
				buttonTable.cmdTable[pullDownLine].isSelect = true;
			end;
		end;
		closePullDownMenue = maxSelect <= 1;
	end;	
	return closePullDownMenue;
end;

function setPullDownBounds(up)	
	if up then
		g_currentMission.guiMenue.pullDown.bounds[1] = g_currentMission.guiMenue.pullDown.bounds[1]-1;
		g_currentMission.guiMenue.pullDown.bounds[2] = g_currentMission.guiMenue.pullDown.bounds[2]-1;
	else
		g_currentMission.guiMenue.pullDown.bounds[1] = g_currentMission.guiMenue.pullDown.bounds[1]+1;
		g_currentMission.guiMenue.pullDown.bounds[2] = g_currentMission.guiMenue.pullDown.bounds[2]+1;
	end;
end;

function setPageLinesBounds(up, modPageTable)
	if up then
		modPageTable.viewLines.bounds[1] = modPageTable.viewLines.bounds[1]-1;
		modPageTable.viewLines.bounds[2] = modPageTable.viewLines.bounds[2]-1
	else
		modPageTable.viewLines.bounds[1] = modPageTable.viewLines.bounds[1]+1;
		modPageTable.viewLines.bounds[2] = modPageTable.viewLines.bounds[2]+1
	end;
end;